#include <stdio.h>
#include <time.h>
#include "DiffEquation.h"

int main(int argc, char **argv)
{    
    clock_t start, finish;
    double duration;
    int i;
    double T = 5.0;
    int m = 5;
    double sigma = 0.3;
    double D = 0.01;
    double K = 100.0;
    double rk_s = 0.015;
    double Ic = 6.0;
    double rf = 0.0253;
    int M = 100;
    int J;
    int n = 5;
    double *stockprice, *cbprice;
    double delta_z;
    FILE *fstockprice, *fcbprice;
    if (argc < 2)
    {
        printf("Input parameters are not correct\n");
        return -1;
    }
    J = atoi(argv[1]);

    // print all parameters
    printf("System parameters:\n");
    printf("\tT=%.1f\n", T);
    printf("\tm=%d\n", m);
    printf("\tsigma=%.1f\n", sigma);
    printf("\tD=%.2f\n", D);
    printf("\tK=%.1f\n", K);
    printf("\trk_s=%.3f\n", rk_s);
    printf("\tIc=%.1f\n", Ic);
    printf("\trf=%.4f\n", rf);
    printf("Grid parameters:\n");
    printf("\tM=%i\n", M);
    printf("\tJ=%i\n", J);
    printf("\tn=%i\n", n);
    //printf("\n");

    start = clock();
    // compute CB and stock prices
    getprices(T, m, sigma, D, K, rk_s, Ic, rf, M, J, n, &stockprice, &cbprice);
    finish = clock();
    duration = ((double)(finish - start)) / ((double)CLOCKS_PER_SEC);		
    printf("Time = %.5f\n", duration);

    // /*
    fstockprice = fopen("stockprice.csv", "w+");
    if (fstockprice == NULL)
    {
        printf("File for saving optimal stock price wasn't created\n");
        free(stockprice);
        free(cbprice);
        return -1;
    }
    fcbprice = fopen("cbprice.csv", "w+");
    if (fcbprice == NULL)
    {
        printf("File for saving CB price wasn't created\n");
        free(stockprice);
        free(cbprice);
        return -1;

    }
    for (i = 0; i < n; i++)
    {
        fprintf(fstockprice, "%lf\n", stockprice[i]);
    }
    delta_z = (log(MAXPRICE) - log(MINPRICE)) / J;
    for (i = 0; i < J + 1; i++)
    {
        fprintf(fcbprice, "%lf;%lf\n", exp(log(MINPRICE) + i * delta_z), cbprice[i]);
    }
    fclose(fstockprice);
    fclose(fcbprice);
    //*/
    free(stockprice);
    free(cbprice);
    return 0;
}